#pragma once
#include "Polygon.h"
#include <ECF.h>

using namespace cutting_stock_graphics;

namespace cutting_stock
{
	class CuttingStockEvalOp : public EvaluateOp, public boost::enable_shared_from_this<CuttingStockEvalOp>
	{	
		public:
			int totalArea = 0; // total area of polygons
			int width = 0;
			std::vector<Polygon> elements;

			void registerParameters(StateP) override;
			bool initialize(StateP) override;
			FitnessP evaluate(IndividualP individual) override;
			bool canBePlaced(Polygon p, const Polygon::Point &point, const std::vector<Polygon> &placedElements) const;

		private:
			int dimension = 0; // number of elements

			static void parseCoordinates(std::ifstream &iFile, std::vector<int> &coordinates);
			static bool rectanglesOverlap(const Polygon &rectA, const Polygon &rectB);

	};
	typedef boost::shared_ptr<CuttingStockEvalOp> CuttingStockEvalOpP;
}
