#pragma once
#include <vector>
#include <boost/shared_ptr.hpp>

namespace cutting_stock_graphics
{
	class Polygon
	{
	private:

	public:
		Polygon();
		Polygon(const Polygon& other);
		~Polygon();

		struct Point {
			int x, y; // float
		};
		struct PointCompare {
			bool operator() (const Point& p1, const Point& p2) const {
				if (p1.y == p2.y)
					return p1.x < p2.x;
				return p1.y < p2.y;
			}
		};

		std::vector<Point> coordinates;
		std::vector<Point> boundingBox;
		int width, height, area;
		int number;

		void addPoint(int, int);
		void setWidth();
		void setHeight();
		void setArea();
		void adjust(const int &x, const int &y);
	};
	typedef boost::shared_ptr<Polygon> PolygonP;
}
