#include "Polygon.h"

namespace cutting_stock_graphics
{
	Polygon::Polygon() : width(0), height(0), area(0), number(0)
	{
	}

	Polygon::Polygon(const Polygon& other)
	{
		width = other.width;
		height = other.height;
		area = other.area;
		number = other.number;
		coordinates = other.coordinates;
		boundingBox = other.boundingBox;
	}

	Polygon::~Polygon()
	{
	}

	void Polygon::addPoint(int x, int y) {
		const Point p = { x, y };
		coordinates.push_back(p);
	}

	// pretpostavlja da su koordinate zadane
	void Polygon::setWidth() {
		width = coordinates[1].x + 1; // tocka w-1
	}

	// pretpostavlja da su koordinate zadane
	void Polygon::setHeight() {
		height = coordinates[2].y + 1; // tocka h-1
	}

	void Polygon::setArea() {
		area = width * height;
	}

	// mnozenje s translacijskom matricom
	void Polygon::adjust(const int &x, const int &y) {
		const auto size = coordinates.size();
		for (auto i = 0; i < size; ++i) {
			coordinates[i] = { coordinates[i].x + x, coordinates[i].y + y };
		}
	}
}